/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.38 Revision 1.50
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.38 2006/10/20 13:14:21 chtekk Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.50 2006/12/16 12:34:29 chtekk Exp $
4 4
5# Author: Francesco Riosa <vivo@gentoo.org> 5# Author: Francesco Riosa <vivo@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 6# Maintainer: Luca Longinotti <chtekk@gentoo.org>
7 7
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too 8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too
23 done 23 done
24 # strip leading "0" (otherwise it's considered an octal number by BASH) 24 # strip leading "0" (otherwise it's considered an octal number by BASH)
25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
26fi 26fi
27 27
28DEPEND="${DEPEND} 28inherit eutils flag-o-matic gnuconfig autotools mysql_fx
29
30# Be warned, *DEPEND are version-dependant
31DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps )
33 >=sys-apps/sed-4
34 >=sys-apps/texinfo-4.7-r1
29 >=sys-libs/readline-4.1 35 >=sys-libs/readline-4.1
30 berkdb? ( sys-apps/ed )
31 ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps )
33 >=sys-libs/zlib-1.2.3 36 >=sys-libs/zlib-1.2.3"
34 >=sys-apps/texinfo-4.7-r1 37
35 >=sys-apps/sed-4" 38# LEAVE THE SURROUNDING SPACES THERE
39MYSQL_MUTUALLY_EXCLUSIVE=" !dev-db/mysql !dev-db/mysql-community "
40DEPEND="${DEPEND} ${MYSQL_MUTUALLY_EXCLUSIVE/ !${CATEGORY}\/${PN} /}"
41
42mysql_version_is_at_least "5.01.00.00" \
43|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
36 44
37RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )" 45RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )"
38 46
39# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 47# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
40PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 48PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
41 49
42inherit eutils flag-o-matic gnuconfig autotools mysql_fx
43
44# Shorten the path because the socket path length must be shorter than 107 chars 50# Shorten the path because the socket path length must be shorter than 107 chars
45# and we will run a mysql server during test phase 51# and we will run a mysql server during test phase
46S="${WORKDIR}/${PN}" 52S="${WORKDIR}/mysql" # BitKeeper ebuilds
47 53
48# Define $MY_FIXED_PV for MySQL patchsets 54# Define $MY_FIXED_PV for MySQL patchsets
49MY_FIXED_PV="${PV/_alpha/}" 55MY_FIXED_PV="${PV/_alpha/}"
50#MY_FIXED_PV="${MY_FIXED_PV/_beta/}" 56#MY_FIXED_PV="${MY_FIXED_PV/_beta/}"
51#MY_FIXED_PV="${MY_FIXED_PV/_rc/}" 57#MY_FIXED_PV="${MY_FIXED_PV/_rc/}"
52 58
59MY_P="${P/_/-}"
60MY_P="${MY_P/-alpha/-bk-}" # BitKeeper ebuilds
61MY_P="${MY_P/-community/}"
62
53# Define correct SRC_URIs 63# Define correct SRC_URIs
54SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${P/_/-}${MYSQL_RERELEASE}.tar.gz" 64SRC_URI="${BASE_URI}/${MY_P}${MYSQL_RERELEASE}.tar.gz"
55if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then 65if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then
56 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2" 66 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2"
57 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball 67 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball
58 SRC_URI="${SRC_URI} http://gentoo.longitekk.com/${MYSQL_PATCHSET_FILENAME}" 68 SRC_URI="${SRC_URI} http://g3nt8.org/patches/${MYSQL_PATCHSET_FILENAME}"
59fi 69fi
60 70
61DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 71DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
62HOMEPAGE="http://www.mysql.com/" 72HOMEPAGE="http://www.mysql.com/"
63SLOT="0" 73SLOT="0"
64LICENSE="GPL-2" 74LICENSE="GPL-2"
65IUSE="big-tables berkdb debug embedded minimal perl selinux srvdir ssl static" 75IUSE="big-tables debug embedded minimal perl selinux srvdir ssl static"
66RESTRICT="confcache" 76RESTRICT="confcache"
67 77
68mysql_version_is_at_least "4.01.00.00" \ 78mysql_version_is_at_least "4.01.00.00" \
69&& IUSE="${IUSE} latin1" 79&& IUSE="${IUSE} latin1"
70 80
77mysql_version_is_at_least "5.00.18.00" \ 87mysql_version_is_at_least "5.00.18.00" \
78&& IUSE="${IUSE} max-idx-128" 88&& IUSE="${IUSE} max-idx-128"
79 89
80mysql_version_is_at_least "5.01.00.00" \ 90mysql_version_is_at_least "5.01.00.00" \
81&& IUSE="${IUSE} innodb" 91&& IUSE="${IUSE} innodb"
92
93mysql_version_is_at_least "5.01.00.00" \
94|| IUSE="${IUSE} berkdb"
82 95
83EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 96EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
84 pkg_postinst pkg_config pkg_postrm 97 pkg_postinst pkg_config pkg_postrm
85 98
86# 99#
121 else 134 else
122 DATADIR="${MY_LOCALSTATEDIR}" 135 DATADIR="${MY_LOCALSTATEDIR}"
123 fi 136 fi
124 einfo "Using default DATADIR" 137 einfo "Using default DATADIR"
125 fi 138 fi
126 einfo "MySQL DATADIR is ${DATADIR}" 139 elog "MySQL DATADIR is ${DATADIR}"
127 140
128 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 141 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
129 if [[ -e "${DATADIR}" ]] ; then 142 if [[ -e "${DATADIR}" ]] ; then
130 ewarn "Previous datadir found, it's YOUR job to change" 143 elog "Previous datadir found, it's YOUR job to change"
131 ewarn "ownership and take care of it" 144 elog "ownership and take care of it"
132 PREVIOUS_DATADIR="yes" 145 PREVIOUS_DATADIR="yes"
133 else 146 else
134 PREVIOUS_DATADIR="no" 147 PREVIOUS_DATADIR="no"
135 fi 148 fi
136 export PREVIOUS_DATADIR 149 export PREVIOUS_DATADIR
142 export MY_INCLUDEDIR 155 export MY_INCLUDEDIR
143 export DATADIR 156 export DATADIR
144} 157}
145 158
146configure_minimal() { 159configure_minimal() {
147 # these are things we exclude from a minimal build 160 # These are things we exclude from a minimal build, please
148 # note that the server actually does get built and installed 161 # note that the server actually does get built and installed,
149 # but we then delete it before packaging. 162 # but we then delete it before packaging.
150 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 163 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication"
151 164
152 for i in ${minimal_exclude_list}; do 165 for i in ${minimal_exclude_list} ; do
153 myconf="${myconf} --without-${i}" 166 myconf="${myconf} --without-${i}"
154 done 167 done
155 myconf="${myconf} --with-extra-charsets=none" 168 myconf="${myconf} --with-extra-charsets=none"
169 myconf="${myconf} --enable-local-infile"
170
171 if useq "static" ; then
172 myconf="${myconf} --with-client-ldflags=-all-static"
173 myconf="${myconf} --disable-shared"
174 else
175 myconf="${myconf} --enable-shared --enable-static"
176 fi
177
178 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
179 myconf="${myconf} --with-charset=utf8"
180 myconf="${myconf} --with-collation=utf8_general_ci"
181 else
182 myconf="${myconf} --with-charset=latin1"
183 myconf="${myconf} --with-collation=latin1_swedish_ci"
184 fi
156} 185}
157 186
158configure_common() { 187configure_common() {
188 myconf="${myconf} $(use_with big-tables)"
159 myconf="${myconf} --enable-local-infile" 189 myconf="${myconf} --enable-local-infile"
160 myconf="${myconf} --with-extra-charsets=all" 190 myconf="${myconf} --with-extra-charsets=all"
161 myconf="${myconf} --with-mysqld-user=mysql" 191 myconf="${myconf} --with-mysqld-user=mysql"
192 myconf="${myconf} --with-server"
162 myconf="${myconf} --with-unix-socket-path='/var/run/mysqld/mysqld.sock'" 193 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
163 myconf="${myconf} --without-libwrap" 194 myconf="${myconf} --without-libwrap"
164 195
165 if useq "static" ; then 196 if useq "static" ; then
166 myconf="${myconf} --with-mysqld-ldflags=-all-static" 197 myconf="${myconf} --with-mysqld-ldflags=-all-static"
167 myconf="${myconf} --with-client-ldflags=-all-static" 198 myconf="${myconf} --with-client-ldflags=-all-static"
168 myconf="${myconf} --disable-shared" 199 myconf="${myconf} --disable-shared"
169 else 200 else
176 myconf="${myconf} --without-debug" 207 myconf="${myconf} --without-debug"
177 mysql_version_is_at_least "4.01.03.00" \ 208 mysql_version_is_at_least "4.01.03.00" \
178 && useq "cluster" \ 209 && useq "cluster" \
179 && myconf="${myconf} --without-ndb-debug" 210 && myconf="${myconf} --without-ndb-debug"
180 fi 211 fi
181 212
182 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 213 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
183 myconf="${myconf} --with-charset=utf8" 214 myconf="${myconf} --with-charset=utf8"
184 myconf="${myconf} --with-collation=utf8_general_ci" 215 myconf="${myconf} --with-collation=utf8_general_ci"
185 else 216 else
186 myconf="${myconf} --with-charset=latin1" 217 myconf="${myconf} --with-charset=latin1"
187 myconf="${myconf} --with-collation=latin1_swedish_ci" 218 myconf="${myconf} --with-collation=latin1_swedish_ci"
188 fi 219 fi
189 220
190 if useq "embedded" ; then 221 if useq "embedded" ; then
191 myconf="${myconf} --with-embedded-privilege-control" 222 myconf="${myconf} --with-embedded-privilege-control"
192 myconf="${myconf} --with-embedded-server" 223 myconf="${myconf} --with-embedded-server"
193 else 224 else
194 myconf="${myconf} --without-embedded-privilege-control" 225 myconf="${myconf} --without-embedded-privilege-control"
221 252
222 # The following fix is due to a bug with bdb on SPARC's. See: 253 # The following fix is due to a bug with bdb on SPARC's. See:
223 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8 254 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
224 # It comes down to non-64-bit safety problems. 255 # It comes down to non-64-bit safety problems.
225 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then 256 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
226 ewarn "bdb berkeley-db disabled due to incompatible arch" 257 elog "Berkeley DB support was disabled due to incompatible arch"
227 myconf="${myconf} --without-berkeley-db" 258 myconf="${myconf} --without-berkeley-db"
228 else 259 else
260 if useq "berkdb" ; then
229 useq "berkdb" && myconf="${myconf} --with-berkeley-db=./bdb" 261 myconf="${myconf} --with-berkeley-db=./bdb"
262 else
263 myconf="${myconf} --without-berkeley-db"
264 fi
230 fi 265 fi
231 266
232 if mysql_version_is_at_least "4.01.03.00" ; then 267 if mysql_version_is_at_least "4.01.03.00" ; then
233 myconf="${myconf} --with-geometry" 268 myconf="${myconf} --with-geometry"
234 myconf="${myconf} $(use_with cluster ndbcluster)" 269 myconf="${myconf} $(use_with cluster ndbcluster)"
235 fi 270 fi
236
237 mysql_version_is_at_least "4.01.11.00" \
238 && myconf="${myconf} $(use_with big-tables)"
239 271
240 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then 272 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
241 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 273 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
242 myconf="${myconf} --with-archive-storage-engine" 274 myconf="${myconf} --with-archive-storage-engine"
243 275
249 281
250 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html 282 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
251 # http://dev.mysql.com/doc/mysql/en/federated-description.html 283 # http://dev.mysql.com/doc/mysql/en/federated-description.html
252 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html 284 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
253 if mysql_version_is_at_least "5.00.03.00" ; then 285 if mysql_version_is_at_least "5.00.03.00" ; then
254 einfo "Before using the Federated storage engine, please be sure to read" 286 elog "Before using the Federated storage engine, please be sure to read"
255 einfo "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 287 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
256 myconf="${myconf} --with-federated-storage-engine" 288 myconf="${myconf} --with-federated-storage-engine"
257 fi 289 fi
258 fi 290 fi
259 291
260 mysql_version_is_at_least "5.00.18.00" \ 292 mysql_version_is_at_least "5.00.18.00" \
261 && useq "max-idx-128" \ 293 && useq "max-idx-128" \
262 && myconf="${myconf} --with-max-indexes=128" 294 && myconf="${myconf} --with-max-indexes=128"
263} 295}
264 296
265configure_51() { 297configure_51() {
266 # TODO : !!!!! readd --withouth-readline 298 # TODO: !!!! readd --without-readline
267 # the failure depend upon config/ac-macros/readline.m4 checking into 299 # the failure depend upon config/ac-macros/readline.m4 checking into
268 # readline.h instead of history.h 300 # readline.h instead of history.h
269 myconf="${myconf} $(use_with big-tables)"
270 myconf="${myconf} $(use_with ssl)" 301 myconf="${myconf} $(use_with ssl)"
271 myconf="${myconf} --enable-assembler" 302 myconf="${myconf} --enable-assembler"
272 myconf="${myconf} --with-geometry" 303 myconf="${myconf} --with-geometry"
273 myconf="${myconf} --with-readline" 304 myconf="${myconf} --with-readline"
274 myconf="${myconf} --with-row-based-replication" 305 myconf="${myconf} --with-row-based-replication"
275 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 306 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
276 myconf="${myconf} --without-pstack" 307 myconf="${myconf} --without-pstack"
277 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 308 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128"
278 309
279 # 5.1 introduces a new way to manage storage engines (plugins) 310 # 5.1 introduces a new way to manage storage engines (plugins)
280 # like configuration=none 311 # like configuration=none
281 local plugins="csv,myisam,myisammrg,heap" 312 local plugins="csv,myisam,myisammrg,heap"
282 if useq "extraengine" ; then 313 if useq "extraengine" ; then
283 # like configuration=max-no-ndb, archive and example removed in 5.1.11 314 # like configuration=max-no-ndb, archive and example removed in 5.1.11
284 plugins="${plugins},blackhole,federated,ftexample,partition" 315 plugins="${plugins},archive,blackhole,example,federated,ftexample,partition"
285 316
286 einfo "before to use federated engine be sure to read" 317 elog "Before using the Federated storage engine, please be sure to read"
287 einfo "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 318 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
288 fi 319 fi
289 320
290 if useq "innodb" ; then 321 if useq "innodb" ; then
291 plugins="${plugins},innobase" 322 plugins="${plugins},innobase"
292 fi 323 fi
305# 336#
306 337
307mysql_pkg_setup() { 338mysql_pkg_setup() {
308 enewgroup mysql 60 || die "problem adding 'mysql' group" 339 enewgroup mysql 60 || die "problem adding 'mysql' group"
309 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 340 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
310 341
311 if mysql_version_is_at_least "5.01.12.00" && useq "innodb" ; then 342 if mysql_version_is_at_least "5.01.12.00" && useq "innodb" ; then
343 eerror "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
312 die "innodb now use cmake to build this is a TODO item" 344 die "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
313 fi 345 fi
314 346
315 # Check for USE flag problems in pkg_setup 347 # Check for USE flag problems in pkg_setup
316 if useq "static" && useq "ssl" ; then 348 if useq "static" && useq "ssl" ; then
317 eerror "MySQL does not support being built statically with SSL support enabled!" 349 eerror "MySQL does not support being built statically with SSL support enabled!"
330 && ( useq "cluster" || useq "extraengine" ) \ 362 && ( useq "cluster" || useq "extraengine" ) \
331 && useq "minimal" ; then 363 && useq "minimal" ; then
332 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 364 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
333 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 365 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
334 fi 366 fi
335 367
368 mysql_check_version_range "4.00.00.00 to 5.00.99.99" \
369 && useq "berkdb" \
336 useq "berkdb" && ewarn "Berkley DB support is deprecated and will be removed in future versions" 370 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
337} 371}
338 372
339mysql_src_unpack() { 373mysql_src_unpack() {
340 # Initialize the proper variables first 374 # Initialize the proper variables first
341 mysql_init_vars 375 mysql_init_vars
342 376
343 unpack ${A} 377 unpack ${A}
344 378
345 mv -f "${WORKDIR}/${P/_/-}${MYSQL_RERELEASE}" "${S}" 379 mv -f "${WORKDIR}/${MY_P}${MYSQL_RERELEASE}" "${S}"
346 cd "${S}" 380 cd "${S}"
347 381
348 # Apply the patches for this MySQL version 382 # Apply the patches for this MySQL version
349 if [[ -d "${WORKDIR}/${MY_FIXED_PV}" ]] ; then 383 if [[ -d "${WORKDIR}/${MY_FIXED_PV}" ]] ; then
350 EPATCH_SOURCE="${WORKDIR}/${MY_FIXED_PV}" EPATCH_SUFFIX="patch" epatch 384 EPATCH_SOURCE="${WORKDIR}/${MY_FIXED_PV}" EPATCH_SUFFIX="patch" epatch
359 find . -name 'Makefile.am' \ 393 find . -name 'Makefile.am' \
360 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 394 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
361 395
362 # Manage mysqlmanager 396 # Manage mysqlmanager
363 mysql_version_is_at_least "5.00.15.00" \ 397 mysql_version_is_at_least "5.00.15.00" \
364 && sed -i -e "s!@GENTOO_EXT@!${MY_SUFFIX}!g" \ 398 && sed -i -e "s!@GENTOO_EXT@!!g" \
365 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \ 399 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
366 "${S}/server-tools/instance-manager/Makefile.am" 400 "${S}/server-tools/instance-manager/Makefile.am"
367 401
368 if mysql_version_is_at_least "4.01.00.00" ; then 402 if mysql_version_is_at_least "4.01.00.00" ; then
369 # Remove what needs to be recreated, so we're sure it's actually done 403 # Remove what needs to be recreated, so we're sure it's actually done
375 rm -f "scripts/mysqlbug" 409 rm -f "scripts/mysqlbug"
376 fi 410 fi
377 411
378 local rebuilddirlist bdbdir d 412 local rebuilddirlist bdbdir d
379 413
380 if mysql_version_is_at_least "5.01.00.00" ; then 414 if mysql_version_is_at_least "5.01.12.00" ; then
381 rebuilddirlist=". storage/innobase" 415 # TODO: innodb is using cmake now?
382 bdbdir='storage/bdb/dist' 416 rebuilddirlist="."
417 bdbdir=''
383 else 418 else
384 rebuilddirlist=". innobase" 419 rebuilddirlist=". innobase"
385 bdbdir='bdb/dist' 420 bdbdir='bdb/dist'
386 fi 421 fi
387 422
390 pushd "${d}" &>/dev/null 425 pushd "${d}" &>/dev/null
391 AT_GNUCONF_UPDATE="yes" eautoreconf 426 AT_GNUCONF_UPDATE="yes" eautoreconf
392 popd &>/dev/null 427 popd &>/dev/null
393 done 428 done
394 429
395 # TODO: berkdb in MySQL 5.1 needs to be worked on
396 if useq "berkdb" \
397 && ! mysql_check_version_range "4.00.00.00 to 4.00.99.99" \ 430 if mysql_check_version_range "4.01.00.00 to 5.00.99.99" \
398 && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then 431 && useq "berkdb" ; then
399 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh" 432 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh"
400 pushd "${bdbdir}" \ 433 pushd "${bdbdir}" \
401 && sh s_all \ 434 && sh s_all \
402 || die "Failed bdb reconfigure" \ 435 || die "Failed bdb reconfigure" \
403 &>/dev/null 436 &>/dev/null
407 440
408mysql_src_compile() { 441mysql_src_compile() {
409 # Make sure the vars are correctly initialized 442 # Make sure the vars are correctly initialized
410 mysql_init_vars 443 mysql_init_vars
411 444
445 # $myconf is modified by the configure_* functions
412 local myconf 446 local myconf=""
413 447
414 if useq "static" ; then
415 myconf="${myconf} --with-mysqld-ldflags=-all-static"
416 myconf="${myconf} --with-client-ldflags=-all-static"
417 myconf="${myconf} --disable-shared"
418 else
419 myconf="${myconf} --enable-shared --enable-static"
420 fi
421
422 myconf="${myconf} --without-libwrap"
423
424 if useq "ssl" ; then 448 if useq "minimal" ; then
425 # --with-vio is not needed anymore, it's on by default and 449 configure_minimal
426 # has been removed from configure 450 else
427 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 451 configure_common
428 if mysql_version_is_at_least "5.00.06.00" ; then 452 if mysql_version_is_at_least "5.01.10.00" ; then
429 # yassl-0.96 is still young and breaks with GCC-4.X or amd64 453 configure_51
430 # myconf="${myconf} --with-yassl"
431 myconf="${myconf} --with-openssl"
432 else 454 else
433 myconf="${myconf} --with-openssl" 455 configure_40_41_50
434 fi
435 else
436 myconf="${myconf} --without-openssl"
437 fi
438
439 if useq "debug" ; then
440 myconf="${myconf} --with-debug=full"
441 else
442 myconf="${myconf} --without-debug"
443
444 mysql_version_is_at_least "4.01.03.00" && useq "cluster" \
445 && myconf="${myconf} --without-ndb-debug"
446 fi
447
448 # These are things we exclude from a minimal build.
449 # Note that the server actually does get built and installed,
450 # but we then delete it.
451 local minimal_exclude_list="server embedded-server extra-tools innodb bench"
452
453 if ! useq "minimal" ; then
454 myconf="${myconf} --with-server"
455 myconf="${myconf} --with-extra-tools"
456
457 if ! mysql_version_is_at_least "5.00.00.00" ; then
458 if useq "raid" ; then
459 myconf="${myconf} --with-raid"
460 else
461 myconf="${myconf} --without-raid"
462 fi 456 fi
463 fi
464
465 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
466 myconf="${myconf} --with-charset=utf8"
467 myconf="${myconf} --with-collation=utf8_general_ci"
468 else
469 myconf="${myconf} --with-charset=latin1"
470 myconf="${myconf} --with-collation=latin1_swedish_ci"
471 fi
472
473 # Optional again with MySQL 5.1
474 if mysql_version_is_at_least "5.01.00.00" ; then
475 if useq "innodb" ; then
476 myconf="${myconf} --with-innodb"
477 else
478 myconf="${myconf} --without-innodb"
479 fi
480 fi
481
482 # Lots of charsets
483 myconf="${myconf} --with-extra-charsets=all"
484
485 # The following fix is due to a bug with bdb on SPARC's. See:
486 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
487 # It comes down to non-64-bit safety problems.
488 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
489 ewarn "bdb berkeley-db disabled due to incompatible arch"
490 myconf="${myconf} --without-berkeley-db"
491 else
492 # TODO: berkdb in MySQL 5.1 needs to be worked on
493 if useq "berkdb" && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
494 myconf="${myconf} --with-berkeley-db=./bdb"
495 else
496 myconf="${myconf} --without-berkeley-db"
497 fi
498 fi
499
500 if mysql_version_is_at_least "4.01.03.00" ; then
501 myconf="${myconf} --with-geometry"
502
503 if useq "cluster" ; then
504 myconf="${myconf} --with-ndbcluster"
505 else
506 myconf="${myconf} --without-ndbcluster"
507 fi
508 fi
509
510 if useq "big-tables" ; then
511 myconf="${myconf} --with-big-tables"
512 else
513 myconf="${myconf} --without-big-tables"
514 fi
515
516 mysql_version_is_at_least "5.01.06.00" \
517 && myconf="${myconf} --with-ndb-binlog"
518
519 if useq "embedded" ; then
520 myconf="${myconf} --with-embedded-privilege-control"
521 myconf="${myconf} --with-embedded-server"
522 else
523 myconf="${myconf} --without-embedded-privilege-control"
524 myconf="${myconf} --without-embedded-server"
525 fi
526
527 # Benchmarking stuff needs Perl
528 if useq "perl" ; then
529 myconf="${myconf} --with-bench"
530 else
531 myconf="${myconf} --without-bench"
532 fi
533 else
534 for i in ${minimal_exclude_list} ; do
535 myconf="${myconf} --without-${i}"
536 done
537 myconf="${myconf} --without-berkeley-db"
538 myconf="${myconf} --with-extra-charsets=none"
539 fi
540
541 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
542 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
543 myconf="${myconf} --with-archive-storage-engine"
544
545 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
546 myconf="${myconf} --with-csv-storage-engine"
547
548 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
549 myconf="${myconf} --with-blackhole-storage-engine"
550
551 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
552 # http://dev.mysql.com/doc/mysql/en/federated-description.html
553 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
554 if mysql_version_is_at_least "5.00.03.00" ; then
555 einfo "Before using the Federated storage engine, please be sure to read"
556 einfo "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
557 myconf="${myconf} --with-federated-storage-engine"
558 fi
559
560 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
561 if mysql_version_is_at_least "5.01.00.00" ; then
562 myconf="${myconf} --with-partition"
563 fi
564 fi
565
566 mysql_version_is_at_least "5.00.18.00" \
567 && useq "max-idx-128" \
568 && myconf="${myconf} --with-max-indexes=128"
569
570 mysql_version_is_at_least "5.01.05.00" \
571 && myconf="${myconf} --with-row-based-replication"
572
573 # TODO: Rechek again later, there were problems with assembler enabled
574 # and some combination of USE flags with MySQL 5.1
575 if mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
576 myconf="${myconf} --disable-assembler"
577 else
578 myconf="${myconf} --enable-assembler"
579 fi 457 fi
580 458
581 # Bug #114895, bug #110149 459 # Bug #114895, bug #110149
582 filter-flags "-O" "-O[01]" 460 filter-flags "-O" "-O[01]"
583 461
584 # glib-2.3.2_pre fix, bug #16496 462 # glib-2.3.2_pre fix, bug #16496
585 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 463 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
586 464
587 append-flags "-fno-exceptions -fno-strict-aliasing" 465 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
588 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 466 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
589 mysql_version_is_at_least "5.00.00.00" \ 467 mysql_version_is_at_least "5.00.00.00" \
590 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 468 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
591 export CXXFLAGS="${CXXFLAGS}" 469 export CXXFLAGS
592 470
593 econf \ 471 econf \
594 --libexecdir="/usr/sbin" \ 472 --libexecdir="/usr/sbin" \
595 --sysconfdir="${MY_SYSCONFDIR}" \ 473 --sysconfdir="${MY_SYSCONFDIR}" \
596 --localstatedir="${MY_LOCALSTATEDIR}" \ 474 --localstatedir="${MY_LOCALSTATEDIR}" \
597 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 475 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
598 --libdir="${MY_LIBDIR}" \ 476 --libdir="${MY_LIBDIR}" \
599 --includedir="${MY_INCLUDEDIR}" \ 477 --includedir="${MY_INCLUDEDIR}" \
600 --with-low-memory \ 478 --with-low-memory \
601 --enable-local-infile \
602 --with-mysqld-user=mysql \
603 --with-client-ldflags=-lstdc++ \ 479 --with-client-ldflags=-lstdc++ \
604 --enable-thread-safe-client \ 480 --enable-thread-safe-client \
605 --with-comment="Gentoo Linux ${PF}" \ 481 --with-comment="Gentoo Linux ${PF}" \
606 --with-unix-socket-path="/var/run/mysqld/mysqld.sock" \
607 --without-readline \
608 --without-docs \ 482 --without-docs \
609 ${myconf} || die "bad ./configure" 483 ${myconf} || die "econf failed"
610 484
611 # TODO: Move this before autoreconf !!! 485 # TODO: Move this before autoreconf !!!
612 find . -type f -name Makefile -print0 \ 486 find . -type f -name Makefile -print0 \
613 | xargs -0 -n100 sed -i \ 487 | xargs -0 -n100 sed -i \
614 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 488 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
615 489
616 emake || die "compile problem" 490 emake || die "emake failed"
617} 491}
618 492
619mysql_src_install() { 493mysql_src_install() {
620 # Make sure the vars are correctly initialized 494 # Make sure the vars are correctly initialized
621 mysql_init_vars 495 mysql_init_vars
622 496
623 make install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "make install error" 497 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
624 498
625 insinto "${MY_INCLUDEDIR}" 499 insinto "${MY_INCLUDEDIR}"
626 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 500 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
627 501
628 # Convenience links 502 # Convenience links
735 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 609 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
736 610
737 if ! useq "minimal" ; then 611 if ! useq "minimal" ; then
738 # Your friendly public service announcement ... 612 # Your friendly public service announcement ...
739 einfo 613 einfo
740 einfo "You might want to run:" 614 elog "You might want to run:"
741 einfo "\"emerge --config =${CATEGORY}/${PF}\"" 615 elog "\"emerge --config =${CATEGORY}/${PF}\""
742 einfo "if this is a new install." 616 elog "if this is a new install."
743 einfo 617 einfo
744 mysql_version_is_at_least "5.01.00.00" \ 618 mysql_version_is_at_least "5.01.00.00" \
745 || einfo "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream." 619 || elog "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream."
746 fi 620 fi
621 mysql_check_version_range "4.00.00.00 to 5.00.99.99" \
622 && useq "berkdb" \
747 useq "berkdb" && ewarn "Berkley DB support is deprecated and will be removed in future versions" 623 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
748} 624}
749 625
750mysql_pkg_config() { 626mysql_pkg_config() {
751 # Make sure the vars are correctly initialized 627 # Make sure the vars are correctly initialized
752 mysql_init_vars 628 mysql_init_vars
753 629
754 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 630 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR"
755 631
756 if built_with_use dev-db/mysql minimal ; then 632 if built_with_use ${CATEGORY}/${PN} minimal ; then
757 die "Minimal builds do NOT include the MySQL server" 633 die "Minimal builds do NOT include the MySQL server"
758 fi 634 fi
759 635
760 local pwd1="a" 636 local pwd1="a"
761 local pwd2="b" 637 local pwd2="b"
856 wait %1 732 wait %1
857 einfo "Done" 733 einfo "Done"
858} 734}
859 735
860mysql_pkg_postrm() { 736mysql_pkg_postrm() {
861 mysql_lib_symlinks 737 : #mysql_lib_symlinks
862} 738}

Legend:
Removed from v.1.38  
changed lines
  Added in v.1.50

  ViewVC Help
Powered by ViewVC 1.1.20